'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InnerButton = undefined;

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _reactackleIcons = require('reactackle-icons');

var _reactackleCore = require('reactackle-core');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var propTypes = {
  disabled: _propTypes2.default.bool,
  /**
   * Full-width TextField doesn't have borders
   */
  fullWidth: _propTypes2.default.bool,
  /**
   * If textfield is dense it has smaller paddings
   */
  dense: _propTypes2.default.bool,
  colorScheme: _propTypes2.default.oneOf(['neutral', 'error', 'success'])
};

var defaultProps = {
  disabled: false,
  fullWidth: false,
  dense: false,
  colorScheme: 'neutral'
};

/** PROP RECEIVERS */
var iconBase = function iconBase(_ref) {
  var themeFromProvider = _ref.theme;

  var theme = (0, _reactackleCore.extractThemeOrDefault)(themeFromProvider);
  var iconSpacing = theme.reactackle.components.textfield.buttonInner.iconSpacing;


  return '\n    margin-left: ' + (0, _reactackleCore.getValueString)(iconSpacing) + ';\n  ';
};

var iconStyle = function iconStyle(_ref2) {
  var themeFromProvider = _ref2.theme,
      disabled = _ref2.disabled,
      colorScheme = _ref2.colorScheme;

  var theme = (0, _reactackleCore.extractThemeOrDefault)(themeFromProvider);
  var path = theme.reactackle.components.textfield.buttonInner.state;
  var source = null;

  if (!disabled) source = colorScheme !== 'neutral' ? path[colorScheme] : path;else source = path.disabled;

  var _source = source,
      color = _source.color,
      opacity = _source.opacity;


  var disabledStyles = (0, _styledComponents.css)(['&,&:hover,&:focus{opacity:', ';cursor:default;box-shadow:none;', '}'], opacity, (0, _reactackleIcons.iconStyleMixin)(color));

  var defaultStyles = (0, _styledComponents.css)(['opacity:', ';cursor:pointer;', ' &:hover{outline:none;color:', ';opacity:', ';box-shadow:none;}&:focus{outline:none;color:', ';opacity:', ';box-shadow:none;}'], opacity, (0, _reactackleIcons.iconStyleMixin)(color), path.hover.color, path.hover.opacity, path.focus.color, path.focus.opacity);

  return disabled ? disabledStyles : defaultStyles;
};

var iconSize = function iconSize(_ref3) {
  var dense = _ref3.dense,
      fullWidth = _ref3.fullWidth,
      themeFromProvider = _ref3.theme;

  var theme = (0, _reactackleCore.extractThemeOrDefault)(themeFromProvider);
  var path = theme.reactackle.components.textfield.buttonInner;

  var source = null;
  if (dense && !fullWidth) source = path.size.dense;else if (dense && fullWidth) source = path.size.denseFullWidth;else if (!dense && fullWidth) source = path.size.fullWidth;else source = path.size;

  var _source2 = source,
      boxSize = _source2.boxSize,
      imgSize = _source2.imgSize;


  return (0, _styledComponents.css)(['     ', ''], (0, _reactackleCore.iconSizeMixin)((0, _reactackleCore.getValueString)(boxSize), (0, _reactackleCore.getValueString)(imgSize || boxSize), (0, _reactackleCore.getValueString)(boxSize)));
};

/** STYLES */
var InnerButton = exports.InnerButton = _styledComponents2.default.div.withConfig({
  displayName: 'InnerButton'
})(['display:flex;background-color:transparent;border:0 solid transparent;padding:0;', ';', ';', ';', ';'], iconBase, iconSize, iconStyle, (0, _reactackleCore.transition)('color, opacity'));

InnerButton.propTypes = propTypes;
InnerButton.defaultProps = defaultProps;
InnerButton.displayName = 'InnerButton';